<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInjectedOfferInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfInjectedOfferInfo extends AbstractStructArrayBase
{
    /**
     * The InjectedOfferInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InjectedOfferInfo[]
     */
    public $InjectedOfferInfo;
    /**
     * Constructor method for ArrayOfInjectedOfferInfo
     * @uses ArrayOfInjectedOfferInfo::setInjectedOfferInfo()
     * @param \StructType\InjectedOfferInfo[] $injectedOfferInfo
     */
    public function __construct(array $injectedOfferInfo = array())
    {
        $this
            ->setInjectedOfferInfo($injectedOfferInfo);
    }
    /**
     * Get InjectedOfferInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InjectedOfferInfo[]|null
     */
    public function getInjectedOfferInfo()
    {
        return isset($this->InjectedOfferInfo) ? $this->InjectedOfferInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInjectedOfferInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInjectedOfferInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInjectedOfferInfoForArrayConstraintsFromSetInjectedOfferInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInjectedOfferInfoInjectedOfferInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfInjectedOfferInfoInjectedOfferInfoItem instanceof \StructType\InjectedOfferInfo) {
                $invalidValues[] = is_object($arrayOfInjectedOfferInfoInjectedOfferInfoItem) ? get_class($arrayOfInjectedOfferInfoInjectedOfferInfoItem) : sprintf('%s(%s)', gettype($arrayOfInjectedOfferInfoInjectedOfferInfoItem), var_export($arrayOfInjectedOfferInfoInjectedOfferInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InjectedOfferInfo property can only contain items of type \StructType\InjectedOfferInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InjectedOfferInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InjectedOfferInfo[] $injectedOfferInfo
     * @return \ArrayType\ArrayOfInjectedOfferInfo
     */
    public function setInjectedOfferInfo(array $injectedOfferInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($injectedOfferInfoArrayErrorMessage = self::validateInjectedOfferInfoForArrayConstraintsFromSetInjectedOfferInfo($injectedOfferInfo))) {
            throw new \InvalidArgumentException($injectedOfferInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($injectedOfferInfo) || (is_array($injectedOfferInfo) && empty($injectedOfferInfo))) {
            unset($this->InjectedOfferInfo);
        } else {
            $this->InjectedOfferInfo = $injectedOfferInfo;
        }
        return $this;
    }
    /**
     * Add item to InjectedOfferInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\InjectedOfferInfo $item
     * @return \ArrayType\ArrayOfInjectedOfferInfo
     */
    public function addToInjectedOfferInfo(\StructType\InjectedOfferInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InjectedOfferInfo) {
            throw new \InvalidArgumentException(sprintf('The InjectedOfferInfo property can only contain items of type \StructType\InjectedOfferInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InjectedOfferInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InjectedOfferInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InjectedOfferInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InjectedOfferInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InjectedOfferInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InjectedOfferInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InjectedOfferInfo
     */
    public function getAttributeName()
    {
        return 'InjectedOfferInfo';
    }
}
