<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCatalogue StructType
 * @subpackage Structs
 */
class GetCatalogue extends AbstractStructBase
{
    /**
     * The user
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WSUser
     */
    public $user;
    /**
     * The Languages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString_1
     */
    public $Languages;
    /**
     * The filter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CatalogueItemsFilter
     */
    public $filter;
    /**
     * Constructor method for GetCatalogue
     * @uses GetCatalogue::setUser()
     * @uses GetCatalogue::setLanguages()
     * @uses GetCatalogue::setFilter()
     * @param \StructType\WSUser $user
     * @param \ArrayType\ArrayOfString_1 $languages
     * @param \StructType\CatalogueItemsFilter $filter
     */
    public function __construct(\StructType\WSUser $user = null, \ArrayType\ArrayOfString_1 $languages = null, \StructType\CatalogueItemsFilter $filter = null)
    {
        $this
            ->setUser($user)
            ->setLanguages($languages)
            ->setFilter($filter);
    }
    /**
     * Get user value
     * @return \StructType\WSUser|null
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param \StructType\WSUser $user
     * @return \StructType\GetCatalogue
     */
    public function setUser(\StructType\WSUser $user = null)
    {
        $this->user = $user;
        return $this;
    }
    /**
     * Get Languages value
     * @return \ArrayType\ArrayOfString_1|null
     */
    public function getLanguages()
    {
        return $this->Languages;
    }
    /**
     * Set Languages value
     * @param \ArrayType\ArrayOfString_1 $languages
     * @return \StructType\GetCatalogue
     */
    public function setLanguages(\ArrayType\ArrayOfString_1 $languages = null)
    {
        $this->Languages = $languages;
        return $this;
    }
    /**
     * Get filter value
     * @return \StructType\CatalogueItemsFilter|null
     */
    public function getFilter()
    {
        return $this->filter;
    }
    /**
     * Set filter value
     * @param \StructType\CatalogueItemsFilter $filter
     * @return \StructType\GetCatalogue
     */
    public function setFilter(\StructType\CatalogueItemsFilter $filter = null)
    {
        $this->filter = $filter;
        return $this;
    }
}
